#!  /usr/local/bin/perl
## 
## whois IPv4 data analysis
## Copyright (C) 2006 The Regents of the University of California.
## 
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
## 
## written by Bradley Huffaker <bradley@caida.org>
## 
## 

use strict;
use FindBin qw($Bin);
require "$Bin/agrUtils.pl";


foreach my $type ("first", "specific") {
    print "<b> $type </b><br>\n";
    print "<table border=\"1\">\n";
    my %rir2prediction = %{GetRirPrediction($type)};
    my @keys = qw(equation a pool);
    print "<tr><th>RIR</th><th>",join("</th><th>", @keys),"</th></tr>\n";
    foreach my $rir (sort keys %rir2prediction) {
	print "<tr><th> $rir </th>";
	foreach my $key (@keys) {
	    print "<td> ";
	    if ($key eq "equation") {
		my $equation = $rir2prediction{$rir}{$key};
		$equation =~ s/2.71828183/<b>e<\/b>/g;
		print $equation;
	    } else {
		my @values = @{$rir2prediction{$rir}{$key}};
		print join(", ", @values);
	    }
	    print "</td>\n";
	}
	print "</tr>";
    }
    print "</table>\n";
}
