#!  /usr/local/bin/perl
## 
## whois IPv4 data analysis
## Copyright (C) 2006 The Regents of the University of California.
## 
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
## 
## written by Bradley Huffaker <bradley@caida.org>
## 
## 

use strict;

my %source;
my %counter;
my $linenum = 0;
while (<>) {
    chop;
    s/#.*//g;
    next unless (/[^\s]/);
my $number = split /\t/;
    my ($inet, $netrange, $netname, $country, $status, $changed, $source) = 
	split /\t/;
print "$source:$number changed:$changed $_\n" unless ($source =~ /[^\s]/);
#unless ($status =~ /[^\s]/) { print "$status:$_\n"; }
#if ($status eq "rir") { print $_,"\n"; }

    $source{$source} = 1;
    $source{"total"} = 1;
    $counter{$status}{$source}++;
    $counter{$status}{"total"}++;
    #last if ($linenum++ > 10);
}

my %length;
my @source = sort keys %source;
foreach my $source (@source) {
    $length{$source} = length($source);
}

my @counter = sort {$counter{$a}{total}<=>$counter{$b}{total}} keys %counter;
my $length = 0;
foreach my $counter (@counter) {
    my $len = length($counter);
    if ($length < $len) {
	$length = $len;
    }
    foreach my $source (@source) {
	my $len = length($counter{$counter}{$source});
	if ($length{$source} < $len) {
	    $length{$source} = $len;
	}
    }
}

my $format = "%-".$length."s";
foreach my $source (@source) {
    $format .= " %".$length{$source}."s";
}
$format .= "\n";

printf $format,"status",@source;
foreach my $counter (@counter) {
    my @values = ($counter);
    foreach my $source (@source) {
	push @values, $counter{$counter}{$source};
    }
    printf $format,@values;
}
